<?php

namespace App\Exports\V2\RoadPatrol\RoadPatrolTable;

use Illuminate\Contracts\View\View;
use Maatwebsite\Excel\Concerns\FromView;
use App\Models\RoadPatrolProject;
use App\Models\Province;
use App\Models\EdarateShahri;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Events\AfterSheet;
use Maatwebsite\Excel\Concerns\WithEvents;
use Illuminate\Support\Facades\DB;
use Maatwebsite\Excel\Concerns\WithDrawings;
use PhpOffice\PhpSpreadsheet\Worksheet\Drawing;

class Cities implements FromView, ShouldAutoSize, WithEvents, WithDrawings
{
    public function __construct($from_date, $date_to)
    {
        $this->from_date = $from_date;
        $this->date_to = $date_to;
    }

    public function view(): View
    {
        $from_date = $this->from_date ?? Date('Y-m-d'). " 00:00:00";
        $date_to = $this->date_to ?? Date('Y-m-d')." 23:59:59";

        $all_province_data = RoadPatrolProject::provincePatrolData($from_date, $date_to);
        $temp = '';
        foreach (Province::all() as $province) {

            $edarat_data = RoadPatrolProject::edarehPatrolData($from_date, $date_to, $province->id);
                foreach (EdarateShahri::where("province_id", $province->id)->get() as $edare_shahri) {
                    $temp = array_search($edare_shahri->id, array_column($edarat_data, 'edare_id'));
                    if ($temp !== false) {
                        $array[] = [
                            'name' => $edare_shahri->name_fa,
                            'is_province' =>0,
                            'tedade' => $edarat_data[$temp]->tedade,
                            'tedad_mavarede_moshede_shode_adi' => $edarat_data[$temp]->tedad_mavarede_moshede_shode_adi,
                            'tedad_mavarede_moshede_shode_fori' => $edarat_data[$temp]->tedad_mavarede_moshede_shode_fori,
                            'tedad_mavarede_moshede_shode_ani' => $edarat_data[$temp]->tedad_mavarede_moshede_shode_ani,
                            'tedad_mavarede_peygiri_shode' => $edarat_data[$temp]->tedad_mavarede_peygiri_shode,
                            'masafat_tey_shode' => $edarat_data[$temp]->masafat_tey_shode,
                            'tedad_faliyat_sabt_shode' => $edarat_data[$temp]->tedad_faliyat_sabt_shode,
                        ];
                    } else {
                        $array[] = [
                            'name' => $edare_shahri->name_fa,
                            'is_province' =>0,
                            'tedade' => "",
                            'tedad_mavarede_moshede_shode_adi' => "",
                            'tedad_mavarede_moshede_shode_fori' => "",
                            'tedad_mavarede_moshede_shode_ani' => "",
                            'tedad_mavarede_peygiri_shode' => "",
                            'masafat_tey_shode' => "",
                            'tedad_faliyat_sabt_shode' => "",
                        ];
                    }
                }
            

            $temp = array_search($province->id, array_column($all_province_data, 'province_id'));

            if ($temp) {
                $array[] = [
                    'name' => $province->name_fa,
                    'is_province' =>1,
                    'tedade' => $all_province_data[$temp]->tedade,
                    'tedad_mavarede_moshede_shode_adi' => $all_province_data[$temp]->tedad_mavarede_moshede_shode_adi,
                    'tedad_mavarede_moshede_shode_fori' => $all_province_data[$temp]->tedad_mavarede_moshede_shode_fori,
                    'tedad_mavarede_moshede_shode_ani' => $all_province_data[$temp]->tedad_mavarede_moshede_shode_ani,
                    'tedad_mavarede_peygiri_shode' => $all_province_data[$temp]->tedad_mavarede_peygiri_shode,
                    'masafat_tey_shode' => $all_province_data[$temp]->masafat_tey_shode,
                    'tedad_faliyat_sabt_shode' => $all_province_data[$temp]->tedad_faliyat_sabt_shode,
                ];
            } else {
                $array[] = [
                    'name' => $province->name_fa,
                    'is_province' =>1,
                    'tedade' => "",
                    'tedad_mavarede_moshede_shode_adi' => "",
                    'tedad_mavarede_moshede_shode_fori' => "",
                    'tedad_mavarede_moshede_shode_ani' => "",
                    'tedad_mavarede_peygiri_shode' => "",
                    'masafat_tey_shode' => "",
                    'tedad_faliyat_sabt_shode' => "",
                ];
            }
            
            
        }


        return view('excel.V2.RoadPatrol.RoadPatrolTable.City', [
            'data' => $array,
            'fromFa' => $from_date,
            'toFa' => $date_to
        ]);
    }

    /**
     * @return array
    */
    public function registerEvents(): array
    {
        return [
            AfterSheet::class    => function (AfterSheet $event) {
                $event->sheet->getDelegate()->setRightToLeft(true);
            }
        ];
    }


    public function drawings()
    {
        $drawing = new Drawing();
        $drawing->setName('Logo');
        $drawing->setDescription('This is my logo');
        $drawing->setPath(public_path('/dist/logo.png'));
        $drawing->setWidth(50);
        $drawing->setHeight(50);
        $drawing->setOffsetX(5);
        $drawing->setOffsetY(5);
        $drawing->setCoordinates('A1');

        $drawing2 = new Drawing();
        $drawing2->setName('Logo');
        $drawing2->setDescription('This is my logo');
        $drawing2->setPath(public_path('/dist/141icon.png'));
        $drawing2->setWidth(50);
        $drawing2->setHeight(50);
        $drawing2->setOffsetX(5);
        $drawing2->setOffsetY(5);
        $drawing2->setCoordinates('H1');
        return [$drawing, $drawing2];
    }
}
